COM_AddCommand("boostalt", function(player, arg)
	if (arg == "on") or (arg == "1") or (arg == "true") then
		CONS_Printf(player, "Alternate Boost set to On")
		player.canboostalt = true
		player.blockc1cancel = true
		if not (player.baltindicator and player.baltindicator.valid)
			player.baltindicator = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BALTIN)
			player.baltindicator.color = SKINCOLOR_BLACK
		end
	end
	if (arg == "off") or (arg == "0") or (arg == "false") then
		CONS_Printf(player, "Alternate Boost set to Off")
		player.canboostalt = false
		player.boostalt = false
		player.blockc1cancel = false
		if (player.baltindicator and player.baltindicator.valid)
			P_KillMobj(player.baltindicator)
		end
	end
end, 0)

local function change(player)
	if (player.boostalt == true) then
		player.boostalt = false
		player.usingdash = false
		player.btimer = nil
		S_StartSound(player.mo, sfx_ncchip)
		player.baltindicator.color = SKINCOLOR_BLACK
		return
	end
	if (player.boostalt == false) then
		player.boostalt = true
		S_StartSound(player.mo, sfx_ncchip)
		player.baltindicator.color = SKINCOLOR_BLUE
		return
	end
end

local function changeboost(player)
	if not (player.mo and player.mo.valid) then
		return
	end
	if (player.mo.skin ~= "spsonic") then
		return
	end
	if (player.canboostalt ~= true) then
		return
	end
	
	P_TeleportMove(player.baltindicator, player.mo.x, player.mo.y, player.mo.z)

	if (player.speed < 1*FRACUNIT and player.midjump == false) then
		return
	end
	if (player.allowtrick == true) then
		return
	end
	if (player.cmd.buttons & BT_CUSTOM1) then
		if not player.pressedbstcustom1
		change(player)
	end
		player.pressedbstcustom1 = true
	else
		player.pressedbstcustom1 = false
	end
end

addHook("PlayerThink", changeboost)